package com.db4o.lib;

import java.io.*;
import java.util.*;

/**
 * @only JAVA
 */
public class File4 extends java.io.File
{
	public File4(String path){
		super(path);
	}
	
	public File4(String path, String file){
		this(String4._right(path,separator) ?  path + file : path + separator + file);
	}
	
	public File4 copy(String toPath){
		try{
			new File4(toPath).mkdirs();
			new File4(toPath).delete();
			final int bufferSize = 64000;
			
			RandomAccessFile rafIn = new RandomAccessFile(getAbsolutePath(),"r");
			RandomAccessFile rafOut = new RandomAccessFile(toPath,"rw");
			long len = rafIn.length();
			byte[] bytes = new byte[bufferSize];
			
			while(len > 0){
				len -= bufferSize;
				if(len < 0){
					bytes = new byte[(int)(len + bufferSize)];	
				}
				rafIn.read(bytes);
				rafOut.write(bytes);
			}
			
			rafIn.close();
			rafOut.close();
			return new com.db4o.lib.File4(toPath);
		}
		catch(Exception e){
			System.out.println("File.copy failed.");
			e.printStackTrace();
			throw new RuntimeException();
		}
	}
	
	public void deleteFiles(){
		String[] files = list();
		for(int i = 0; i < files.length; i ++){
			File4 file = new File4(getAbsolutePath(), files[i]);
			if(file.isDirectory()){
				file.deleteFiles();
			}else{
				file.delete();
			}
		}
	}
	
	public void replace(String a_replace, String a_with){
		String path = getAbsolutePath();
		String4 str = null;
		RandomAccessFile raf = null;
		int len = 0;
		byte l_bytes[] = null;
		try{
			if(! exists()){
				throw new Exception();
			}
			raf = new RandomAccessFile(path,"rw");
		}
		catch(Exception e){
			System.out.println("Failed to open file: " + path);
			return;
		}
			
		try{
			len = (int)raf.length();
			l_bytes = new byte[len];
			raf.read(l_bytes,0,len);
			raf.close();
		}
		catch(Exception e){
			System.out.println("File read denied:" + path);
			return;
		}
			
		str = new String4(new String(l_bytes));
		str.replace(a_replace,a_with);
		l_bytes = str.getString().getBytes();
		
		try{
			new File4(path).delete();
		}catch(Exception e){
			System.out.println("File access denied: " + path);
			return;
		}
			
		try{
			raf = new RandomAccessFile(path,"rw");
			raf.write(l_bytes);
			raf.close();
		}
		catch(Exception e){
			System.out.println("File access denied: " + path);
			return;
		}
	}
}
