package com.db4o.samples.update;

import com.db4o.*;
import com.db4o.samples.*;

public class U02_Update_Every_Object_Explicly extends U01_New_Always_Cascades
{
	public static void main(String[] args){
		new U02_Update_Every_Object_Explicly().update();
	}
	
	public void update(){
		createDB();
		System.out.println("ROOT UPDATED");
		updateRootOnly();
		logLists(); // no change
		System.out.println("CHANGED OBJECT UPDATED");
		updateChangedObject();
		logLists();
	}
	
	public void updateRootOnly(){
		ObjectContainer con = Db4o.openFile(filename);
		ObjectSet set = con.get(new ListSample(1));
		while(set.hasNext()){
			ListSample root = (ListSample)set.next();
			root.next.intField = root.next.intField + 1000;
			
			// This statement will only update "root" and cascade to possible new members
			// By default it will not cascade to changed members
			con.set(root); 
			
		}
		con.close();
	}
	
	public void updateChangedObject(){
		ObjectContainer con = Db4o.openFile(filename);
		ObjectSet set = con.get(new ListSample(1));
		while(set.hasNext()){
			ListSample root = (ListSample)set.next();
			root.next.intField = root.next.intField + 1000;
			
			// Here we update the changed object explicitely
			con.set(root.next);
			
		}
		con.close();
	}
}
