package com.db4o.test;

import java.io.*;
import java.util.*;

import com.db4o.*;
import com.db4o.lib.*;

public class RegressionCS extends Regression
{
	private static boolean runNormalDb4o = false;
	private static boolean runServer = false;
	private static final String HOST_NAME = "YETAC";
	private static final int SERVER_PORT = 4444;
	private static final String SERVER_FILE = "server.yap";
	
	public static void main(String[] args){
		System.out.println("Client Server Regression Test");
		
		boolean useServer =  runServer; /* && ! com.db4o.Debug.fakeServer  */
		
		// Db4o.configure().encrypt(true);
		// Db4o.configure().password("Houilo7");
		// Db4o.configure().messageLevel(1);
		Db4o.configure().unicode(false);
		ObjectServer server = null;
		
		if(useServer){
			new File(SERVER_FILE).delete();
			try{
				server = Db4o.openServer(SERVER_FILE, SERVER_PORT);
				server.grantAccess("db4o", "db4o");
			}catch(Exception e){
				e.printStackTrace();
			}
		}else{
			new File(Regression.file).delete();
		}
		
		RegressionCS re = new RegressionCS();
		re.run();
		
		if(useServer){
			server.close();
		}
	}

	public ObjectContainer openContainer(){
		try{
			/*
			if(com.db4o.Debug.fakeServer){
				return new YapClient(Regression.file);
			}else{
				return Db4o.openClient(HOST_NAME,SERVER_PORT,"db4o","db4o");
			}
			*/
			return Db4o.openClient(HOST_NAME,SERVER_PORT,"db4o","db4o");
		}catch(Exception e){
			e.printStackTrace();
			System.out.println("Could not connect to server. Settings:");
			System.out.println("Host Name: " + HOST_NAME + "   Port:" + SERVER_PORT);
			System.out.println("Check the variables in RegressionCS.java");
		}
		return null;
	}
	
	private static ObjectContainer debugCon(){
		try{
			if(runNormalDb4o){
				return Db4o.openFile(Regression.file);
			}else{
				/*
				if(com.db4o.Debug.fakeServer){
					return new YapClient(Regression.file);
				}else{
					return Db4o.openClient(HOST_NAME,SERVER_PORT,"db4o","db4o");
				}
				*/
				return Db4o.openClient(HOST_NAME,SERVER_PORT,"db4o","db4o");
				
			}
		}catch(Exception e){
		}
		return null;
	}
}
