package com.db4o.test;

import java.io.*;

import com.db4o.*;


public class Test {
	
	private static ObjectServer objectServer;
	private static ObjectContainer objectContainer;
	
	public static void main(String[] args){
		// run AllTests class
	}
	
	public static void close(){
		while(! objectContainer.close());
		objectContainer = null;
	}
	
	public static void delete(){
		new File(TestConfiguration.FILE).delete();
	}
	
	public static void deleteAllInstances(Object obj){
		try{
			Class clazz = obj.getClass();
			obj = clazz.newInstance();
			objectContainer.deactivate(obj, Integer.MAX_VALUE);
			ObjectSet set = objectContainer.get(obj);
			while(set.hasNext()){
				objectContainer.delete(set.next());
			}
			objectContainer.commit();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public static void end(){
		if(objectContainer != null){
			while(! objectContainer.close());
		}
		if(objectServer != null){
			objectServer.close();
		}
	}
	
	public static void ensure(boolean condition){
		if(! condition){
			error();
		}
	}
	
	public static void ensureOccurrences(Object obj, int count){
		ensure( occurrences(obj) == count);
	}
	
	public static void error(){
		new Exception().printStackTrace();
	}
	
	public static ObjectContainer objectContainer(){
		if(objectContainer == null){
			open();
		}
		return objectContainer;
	}
	
	public static int occurrences(Object obj){
		try{
			Class clazz = obj.getClass();
			obj = clazz.newInstance();
			objectContainer.deactivate(obj, Integer.MAX_VALUE);
			return objectContainer.get(obj).size();
		}catch(Exception e){
			e.printStackTrace();
			return 0;
		}
	}
	
	public static ObjectContainer open(){
		if(TestConfiguration.runServer && TestConfiguration.clientServer  && objectServer == null){
			objectServer = Db4o.openServer(TestConfiguration.FILE, TestConfiguration.SERVER_PORT);
			objectServer.grantAccess(TestConfiguration.DB4O_USER, TestConfiguration.DB4O_PASSWORD);
			objectServer.ext().configure().messageLevel(0);
		}
		if(TestConfiguration.clientServer){
			try{
				objectContainer = Db4o.openClient(TestConfiguration.SERVER_HOSTNAME, TestConfiguration.SERVER_PORT, TestConfiguration.DB4O_USER, TestConfiguration.DB4O_PASSWORD);
			}catch(Exception e){
				e.printStackTrace();
				return null;
			}
		}else{
			objectContainer = Db4o.openFile(TestConfiguration.FILE);
		}
		return objectContainer;
	}
	
	
	public static ObjectContainer reOpen(){
		close();
		return open();
	}
	
}
