package com.db4o.test.types;

import com.db4o.test.*;

public class Entry {

	public Object key;
	public Object value;

	public Entry(){
	}

    public Entry(Object key, Object value) {
		this.key = key;
		this.value = value;
    }

	public Entry firstElement(){
		return new Entry("first", "firstvalue");
	}

	public Entry lastElement(){
		return new Entry(new ObjectSimplePublic("lastKey"), new ObjectSimplePublic("lastValue"));
	}

	public Entry noElement(){
		return new Entry("NO", "babe");
	}

	public Entry[] test(int ver){
		if(ver == 1){
			return new Entry[]{
				firstElement(),
				new Entry(new Integer(111), new ObjectSimplePublic("111")),
				new Entry(new Long(9999111), new Double((double)0.4566)),
				/*
				
				need to extend compare for the following
				
				new Entry(
					new ObjectSimplePublic[]{
						new ObjectSimplePublic("killer1"), new ObjectSimplePublic("killer2")
					},
					new ObjectSimplePublic[]{
						new ObjectSimplePublic("killer3"), null, new ObjectSimplePublic("killer4")
					}
				),
				*/
				lastElement()
			};
		}
		return new Entry[]{
			new Entry(new Integer(222), new ObjectSimplePublic("111")),
			new Entry("222", "TrippleTwo"),
			new Entry(new ObjectSimplePublic("2222"), new ObjectSimplePublic("222")),
		};
	}

	public void compare(Entry[] a_cmp, int oneOrTwo, boolean keysOnly){
		Entry[] tests = test(oneOrTwo);
		Entry[] cmp = new Entry[a_cmp.length];
		System.arraycopy(a_cmp,0, cmp, 0, a_cmp.length);
		if(cmp == null){
			Regression.addError("Entry:argument is null");
			return;
		}
		if(cmp.length  != tests.length){
			Regression.addError("Entry:arrays of different length");
			return;
		}
		for(int i = 0; i < tests.length; i ++){
			boolean found = false;
			for(int j=0; j < cmp.length; j++){
				if(cmp[j] != null){
					if(tests[i].key.equals(cmp[j].key)){
						if(!keysOnly){
							if(! tests[i].value.equals(cmp[j].value)){
								Regression.addError("Entry:inequality");
								return;
							}
						}
						cmp[j] = null;
						found = true;
						break;
					}
				}
			}
			if(! found){
				
				Regression.addError("element not found");
			}
		}
	}
}